/*
 *  Copyright (C) 2007-2015 Lonelycoder AB
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  This program is also available under a commercial proprietary license.
 *  For more information, contact andreas@lonelycoder.com
 */
#pragma once

typedef struct glw_rec glw_rec_t;
struct pixmap;
struct AVFrame;
struct audio_decoder;

glw_rec_t *glw_rec_init(const char *filename, int width, int height, int fps);

void glw_rec_deliver_vframe(glw_rec_t *gr, struct pixmap *pm);

void glw_rec_stop(glw_rec_t *);

void glw_rec_audio_send(struct audio_decoder *ad, struct AVFrame *frame,
                        int64_t pts);
